Bug Hunting Session
Bug 34392 - Start Center: Room for GUI words does not not increase with scale
Summary: Start Center: Room for GUI words does not not increase with scale
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
3.3.0 release
Hardware: All All
: low minor
Assignee: Ivan Timofeev (retired)
URL:
Whiteboard: target:3.6.0 target:3.7.0
Keywords: difficultyBeginner, easyHack, skillCpp, skillVcl, topicUI
Depends on:
Blocks:
 
Reported: 2011-02-17 06:18 UTC by sasha.libreoffice
Modified: 2015-12-15 12:18 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
Little Demo Presentation (146.12 KB, application/vnd.oasis.opendocument.presentation)
2011-03-02 03:22 UTC, Rainer Bielefeld Retired
Details
Start Center with long text on the buttons (63.46 KB, image/png)
2011-12-30 09:01 UTC, Ivan Timofeev (retired)
Details
Screenshots for different languages (24.95 KB, application/pdf)
2011-12-30 09:51 UTC, Rainer Bielefeld Retired
Details
New screenshots (44.81 KB, application/pdf)
2011-12-30 11:12 UTC, Rainer Bielefeld Retired
Details
Partial fix: recompute column widths in BackingWindow::Resize() (2.33 KB, patch)
2012-04-06 16:43 UTC, Gábor Stefanik
Details
Resize backing window on window size change. (859 bytes, patch)
2012-04-09 11:22 UTC, Gábor Stefanik
Details

Note You need to log in before you can comment on or make changes to this bug.
Description sasha.libreoffice 2011-02-17 06:18:52 UTC
I have set this:
Tools->Options->LibreOffice->Viev->User Interface->Scaling to 130%

When I start LibreOffice, appears screen with variants of document types to be created. But in place of "Text Documents" appears "Text Docume"

On other languages situation ever worse
Comment 1 sasha.libreoffice 2011-02-24 04:59:05 UTC
In libreoffice 3.3.1 still exist
Comment 2 Rainer Bielefeld Retired 2011-03-02 02:58:38 UTC
[Reproducible] with "LibreOffice 3.3.1  – WIN7  Home Premium  (64bit) German UI [OOO330m19 (build 8 / tag 3.3.1.2)]". Not really annoying, but ugly!
Comment 3 Rainer Bielefeld Retired 2011-03-02 03:22:30 UTC
Created attachment 44013 [details]
Little Demo Presentation
Comment 4 Björn Michaelsen 2011-12-23 11:50:37 UTC
[This is an automated message.]
This bug was filed before the changes to Bugzilla on 2011-10-16. Thus it
started right out as NEW without ever being explicitly confirmed. The bug is
changed to state NEEDINFO for this reason. To move this bug from NEEDINFO back
to NEW please check if the bug still persists with the 3.5.0 beta1 or beta2 prereleases.
Details on how to test the 3.5.0 beta1 can be found at:
http://wiki.documentfoundation.org/QA/BugHunting_Session_3.5.0.-1

more detail on this bulk operation: http://nabble.documentfoundation.org/RFC-Operation-Spamzilla-tp3607474p3607474.html
Comment 5 sasha.libreoffice 2011-12-30 00:29:53 UTC
remains in LibO 3.5.0 beta 1
Comment 6 Rainer Bielefeld Retired 2011-12-30 01:21:11 UTC
So it is. In Beta2 I see other Buttons (for example 'Tools -> Options -> LibO -> Security -> Macro Security...') Increasing and decreasing together with View zoom, that function should also be possible for buttons in Start Center.

@Ivan:
You know ... ;-)
Comment 7 Rainer Bielefeld Retired 2011-12-30 02:20:34 UTC
Ma description was a little imprecise, it's not only the size of the buttons that follows View zoom, but the whole dialog size increases or decreases with the zoom for dialogs.
Comment 8 Ivan Timofeev (retired) 2011-12-30 09:01:26 UTC
Created attachment 54975 [details]
Start Center with long text on the buttons


(In reply to comment #6)
> @Ivan:
> You know ... ;-)

Yeah... :-)

First of all I actually want to see the "Scaling" option burning in hell. With excruciating pain and suffering. Hope we will remove it in 3.6...

Secondly I can not reproduce the bug. I've added some garbage to the text to increase its width, and the buttons made wider too. See the attached screenshot.
Comment 9 Ivan Timofeev (retired) 2011-12-30 09:13:30 UTC
(In reply to comment #8)
> Secondly I can not reproduce the bug. I've added some garbage to the text to
> increase its width, and the buttons made wider too. See the attached
> screenshot.

Oh wait, I've just reproduced it! But when restarting the start center the width become normal. Sorry...
Comment 10 Rainer Bielefeld Retired 2011-12-30 09:51:55 UTC
Created attachment 54977 [details]
Screenshots for different languages

@Ivan:
Text length and View zoom are different things. Can it be that there is some "Button auto size" for maximum text length at View zoom 100%? Also your extra long button texts ave approximate 4mm distance to right button border for the longest text.

I tried several languages and the margins for the most long text to right button border and icon are always the same.

And when I Resize to 130% in each language at least the longest button text exceeds the button

The Screenshots are all for View zoom 100%, not with correct scaling
Comment 11 Ivan Timofeev (retired) 2011-12-30 10:08:33 UTC
(In reply to comment #10)
> Created attachment 54977 [details]
> Screenshots for different languages

? I see only dimensional information layer.

> @Ivan:
> Text length and View zoom are different things. Can it be that there is some
> "Button auto size" for maximum text length at View zoom 100%?

Should not be I think...

> I tried several languages and the margins for the most long text to right
> button border and icon are always the same.
> 
> And when I Resize to 130% in each language at least the longest button text
> exceeds the button

... and when you press some button and then Ctrl-W ... ? :) All should be fine.
Comment 12 Rainer Bielefeld Retired 2011-12-30 11:12:41 UTC
Created attachment 54982 [details]
New screenshots

@Ivan:
Indeed! Start situation is Start Center, 130% View zoom with truncated button texts. Clicking an arbitrary button (Text Document) opens a new document, <control+w> will close it again, and texts in start center buttons now look fine, button size has increased. Where can I read more about mysterious "<control+w>"?
Comment 13 Ivan Timofeev (retired) 2012-01-06 06:34:40 UTC
(In reply to comment #12)
> Where can I read more about mysterious"<control+w>"?

It is a shortcut for Window -> Close Window. No any mystery here... :)
Comment 15 Gábor Stefanik 2012-04-06 16:43:34 UTC
Created attachment 59611 [details]
Partial fix: recompute column widths in BackingWindow::Resize()

This fixes the issue for me on LibreOffice startup. However, the issue still persists right after changing the scale factor.

It appears that BackingWindow::Resize() gets called in the scale-factor-changed case *before* the new scaling factor/font size is set. As a result, the column width ends up being calculated according to the old scale factor.

If anyone can point me to the place where BackingWindow::Resize() is called upon scale factor change, that would be greatly appreciated.
Comment 16 Gábor Stefanik 2012-04-09 11:22:22 UTC
Created attachment 59687 [details]
Resize backing window on window size change.

Apply this on top of attachment 59611 [details]. This appears to completely fix shrunk buttons.

However, while testing, I've noticed one instance with too wide buttons (I can't remember how I triggered it). Also, this doesn't fix the root issue (Resize() being called too early), it merely works around it by calling Resize() again at a point where the new font is surely available. A followup bug should probably be filed for the root issue, and this second patch reverted once that is fixed.
Comment 17 Not Assigned 2012-04-12 05:13:14 UTC
Gabor Stefanik committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=5f2825dde8a44773fc6ce19f2dd4e328c4e88eaf

fdo#34392 recompute column widths after font scale change in startcenter
Comment 18 Gábor Stefanik 2012-04-13 16:48:04 UTC
Fix checked in.
Comment 19 Not Assigned 2012-09-22 10:50:02 UTC
Ivan Timofeev committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=b40f95f9159c3868a059b33fb524ccc7ed182272

fdo#34392: request button size after vcl has updated its settings



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 20 Robinson Tryon (qubit) 2015-12-15 12:18:18 UTC
Migrating Whiteboard tags to Keywords: (EasyHack DifficultyBeginner SkillCpp SkillVcl TopicUI)
[NinjaEdit]